#include <netinet/in.h>
#include <pthread.h>
#include <stdio.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <unistd.h>

void (*routes[])() = {};
int size = 0;

void serve(
        int port,
        char addr[],
        void (*router)(char subdomain[], char method[], char route[]),
        void (*callback)(int port, char addr[])
) {
        callback(port, addr);
        router("www", "GET", "/");
};

void *handleSocket(void * connection_file_descriptor) {
        int acknowledgement = 0;
        for (;;) {
                char buffer[256] = {};
                read((int *) connection_file_descriptor, buffer, sizeof(buffer));
                if (acknowledgement == 0) {
                        write(connection_file_descriptor, 0, 1);
                        acknowledgement = 1;
                };
                printf("%i Request: %s\n", (int *) connection_file_descriptor, buffer);
                char response;
                char status = 0;
                write((int *) connection_file_descriptor, &response, sizeof(response));
        };
        pthread_exit(NULL);
};

void _TCP() {
        struct sockaddr_in server_sockaddr_in;
        server_sockaddr_in.sin_family = AF_INET;
        server_sockaddr_in.sin_addr.s_addr = htonl(INADDR_ANY);
        server_sockaddr_in.sin_port = htons(80);
        int socket_file_descriptor = socket(AF_INET, SOCK_STREAM, 0);
        bind(socket_file_descriptor, (struct sockaddr *)&server_sockaddr_in, sizeof(server_sockaddr_in));
        listen(socket_file_descriptor, 5);
        pthread_t threadId;
        for (;;) {
                struct sockaddr_in client_sockaddr_in;
                socklen_t len = sizeof(client_sockaddr_in);
                int connection_file_descriptor = accept(socket_file_descriptor, (struct sockaddr *)&client_sockaddr_in, &len);
                pthread_create(&threadId, NULL, handleSocket, connection_file_descriptor);
        };
        close(socket_file_descriptor);
};
